<script setup lang="ts">
import { nextTick, ref } from 'vue'
import ProductList from '@/components/pos/ProductList.vue'
import ReceipDetailTable from '@/components/pos/ReceipDetailTable.vue'
import ReceipCard from '@/components/pos/ReceipCard.vue'
import ReceiptDialog from './ReceiptDialog.vue'
import ReceiptPaper from './ReceiptPaper.vue'
import MemberCard from '@/components/pos/MemberCard.vue'
import ProductDetailDialog from './ProductDetailDialog.vue'
import { type Product } from '@/types/Product'

import { onMounted } from 'vue'
import { useReceiptStore } from '@/stores/receipt'
import { usePosStore } from '@/stores/pos'
import { useRouter } from 'vue-router'
import { useProductStore } from '@/stores/product'

const router = useRouter()
const receiptStore = useReceiptStore()
const productStore = useProductStore()
const posStore = usePosStore()

const tab = ref(null)
const product = ref<Product>()
const divreceipItems = ref<HTMLLIElement | null>(null)

function selected(p: Product) {
  if (!p.id) return
  product.value = p
  const pd: Product = {
    id: p.id,
    name: p.name,
    price: p.price,
    type: p.type,
    category: '',
    sweet: 100,
    image: 'noimage.png'
  }
  if (p.type.name === "drink") {
      productStore.addProduct(pd)
      posStore.productCard = true
    } else {
      receiptStore.addReceiptItem(pd)
    }

  console.log(`ProductView` + p)


  nextTick(() => {
    if (divreceipItems.value) divreceipItems.value.scrollTo(0, divreceipItems.value.scrollHeight)
  })
}

function pushMember() {
  router.push('/member')
}

function pushReceiptHistory() {
  router.push('/receiptHistory')
}

onMounted(async () => {
  await posStore.getProducts()
  await productStore.getProducts()
  await receiptStore.getOrders()
})
</script>

<template>
  <v-containe overflow-y="auto">
    <v-row style="width: auto; height: auto">
      <v-col col="12" xl="6">
        <div>
          <v-tabs
            v-model="tab"
            align-tabs="center"
            height="50"
            class="bgHeader"
            style="padding: auto; color: ghostwhite; font-size: medium"
          >
            <v-tab :value="1" class="text">Coffee</v-tab>
            <v-tab :value="2" class="text">Snack</v-tab>
            <v-tab :value="3" class="text">Orther</v-tab>
          </v-tabs>
        </div>
        <v-sheet
          min-width="450"
          max-width="900"
          height="790"
          class="bgCard"
          style="overflow-y: auto"
        >
          <v-window v-model="tab">
            <v-window-item :value="1">
              <ProductList
                :products="posStore.products1"
                @selected-product="selected"
              ></ProductList>
            </v-window-item>
            <v-window-item :value="2">
              <ProductList
                :products="posStore.products2"
                @selected-product="selected"
              ></ProductList>
            </v-window-item>
            <v-window-item :value="3">
              <ProductList
                :products="posStore.products3"
                @selected-product="selected"
              ></ProductList>
            </v-window-item>
          </v-window>
        </v-sheet>
      </v-col>

      <v-col col="12" xl="6">
        <v-container style="padding: 0">
          <v-row>
            <v-col col="12">
              <div ref="divreceipItems" style="height: 300; overflow: auto">
                <v-sheet min-width="500" max-width="900" height="410" elevation="6">
                  <ReceipDetailTable
                    v-model="receiptStore.receiptItems"
                    :editable="true"
                  ></ReceipDetailTable>
                </v-sheet>
              </div>
            </v-col>

            <v-col col="12">
              <v-sheet min-width="450" max-width="900" height="80" class="bgCard">
                <MemberCard></MemberCard>
              </v-sheet>
            </v-col>

            <v-col col="12">
              <v-sheet min-width="450" max-width="900" height="200">
                <ReceipCard></ReceipCard>
              </v-sheet>
            </v-col>

            <v-col col="12">
              <v-sheet min-width="450" class="bgCard">
                <v-container>
                  <v-row col="12">
                    <v-col col="3">
                      <v-btn
                        rounded="xl"
                        size="large"
                        color="#474747"
                        @click="pushReceiptHistory()"
                      >
                        ReceiptHistory<v-icon
                          icon="mdi-receipt-clock-outline"
                          end
                        ></v-icon>
                      </v-btn>
                    </v-col>
                    <v-col col="3">
                      <v-btn
                        rounded="xl"
                        size="large"
                        color="#474747"
                        @click="pushMember()"
                      >
                        RegisterMember<v-icon
                          icon="mdi-account-multiple-plus"
                          end
                        ></v-icon>
                      </v-btn>
                    </v-col>
                    <v-col col="3">
                      <v-btn
                        block
                        rounded="xl"
                        size="large"
                        color="red"
                        @click="receiptStore.clear()"
                      >
                        Cancel<v-icon icon="mdi-minus-circle" end></v-icon>
                      </v-btn>
                    </v-col>
                    <v-col col="3">
                      <v-btn
                        block
                        rounded="xl"
                        size="large"
                        color="green"
                        @click="receiptStore.showReceipt()"
                      >
                        Payment<v-icon icon="mdi-checkbox-marked-circle" end></v-icon
                      ></v-btn>
                    </v-col>
                  </v-row>
                </v-container>
              </v-sheet>
            </v-col>
          </v-row>
        </v-container>
      </v-col>
    </v-row>
  </v-containe>
  <ReceiptDialog></ReceiptDialog>
  <ReceiptPaper></ReceiptPaper>
  <ProductDetailDialog v-if="posStore.productCard === true"></ProductDetailDialog>
</template>

<style scoped>
.bgHeader {
  background-color: #8b8b8b;
}

.bgCard {
  background-color: #acaaaa;
}

.text {
  color: ghostwhite;
  font-size: medium; /* เปลี่ยนขนาดตัวอักษรเป็นขนาดปกติ */
  font-weight: bold; /* ทำให้ตัวอักษรหนาขึ้น */
}
</style>
